# This is a GAP demonstration file. 
# To run a demonstration enter the following:
# gap> ReadLib("demo.g");
# gap> Demonstration("GAPdemo.g");
# (probably you will need the full path in the last 
# command). Then you may press <Enter> to go to the 
# next step or press <q> to terminate demonstration
#
# -------------------------------------------------
#
# First, you can use the GAP system as a calculator
#
2*2;
(4+130)*(5+6);
a:=100;
b := 25;
(a + 50 ) / b;
1235/67890;
2^200; # long integers
2^15000;
Length(String(last));
a := 2^20000;
a mod 1000;
(245446687*a+166567) mod 11;
a := 2^43112609-1; # The biggest known Mersenne Prime (30.06.2009)
a mod 10^5;
2*Z(3); # finite field elements 
3*Z(3);
l := [ 2, 3, 5, 7 ]; # lists and sets
List( l, x -> x^2 );
m := [ 1 .. 100 ];
Filtered( m, IsPrime );
k := [ 5, 3, 2, true, 5, , , 100, , "this is a string", E(4) ];
IsSet(k);
Set(k);
x:=X(Rationals,"x"); # polynomials
RootsOfUPol(50-45*x-6*x^2+x^3);
y:=X(Rationals,"y");
z:=X(Rationals,"z");
l:=[x^2+y^2+z^2-1,x^2+z^2-y,x-y]; # Groebner basis
GroebnerBasis(l,MonomialLexOrdering());
GroebnerBasis(l,MonomialLexOrdering([z,x,y]));
GroebnerBasis(l,MonomialGrlexOrdering());
Read("sudoku.g"); # How to solve Sudoku with GAP ?
puzzle := [
[9,1,2, , ,5,8, , ],
[6, , ,9, ,3, , ,1],
[4, , , , , , , , ],
[1,5, ,6, , , , , ],
[ , ,6, , , ,5, , ],
[ , , , , ,9, ,8,7],
[ , , , , , , , ,8],
[5, , ,3, ,8, , ,6],
[ , ,3,5, , ,2,7,9]
];
Display( Sudoku( puzzle ) );
(1,2,3); # permutations and permutation groups
(1,2,3)*(1,2);
(1,2,3)^-1;
2^(1,2,3);
(1,2,3)^(1,2);
s8:=Group( (1,2), (1,2,3,4,5,6,7,8) );
a8:=DerivedSubgroup(s8);
Size(a8);
IsAbelian(a8);
ConjugacyClasses(a8);
s10:=SymmetricGroup(10);
a10:=AlternatingGroup(10);
F:=FreeGroup("a","b"); # Groups by defining relations
a:=F.1;
b:=F.2;
rels := [ a^4, b^2, b^-1*a*b*a ];
G:=F/rels;
IdGroup(G);
D:=DihedralGroup(8);
IdGroup(D);